import java.awt.*;

class ContrDisegnoPunti extends Panel {
	Disegno disegno;
	Checkbox checkboxAggiungi;

	ContrDisegnoPunti(Disegno disegno) {
		this.disegno = disegno;
		Panel pannello=new Panel();
      pannello.setLayout(new GridLayout(5,1,0,1));
		pannello.add(new Label("PUNTI",Label.CENTER));
		CheckboxGroup checkboxGroup = new CheckboxGroup();
		pannello.add(checkboxAggiungi=new Checkbox("Aggiungi",checkboxGroup,true));
		pannello.add(new Checkbox("Muovi",checkboxGroup,false));
      pannello.add(new Checkbox("Togli",checkboxGroup,false));
		pannello.add(new Button("Pulisci"));
		add(pannello);
	}

	public boolean action(Event e, Object arg) {
		if (e.target instanceof Checkbox) {
			if (((Checkbox)e.target).getLabel().equals("Aggiungi")) disegno.impostaModPunti(Disegno.AGG_PUNTO);
			else if (((Checkbox)e.target).getLabel().equals("Muovi")) disegno.impostaModPunti(Disegno.MUOVI_PUNTO);
			else disegno.impostaModPunti(Disegno.CANC_PUNTO);
			return true;
		}
		if (e.target instanceof Button) {
			disegno.eliminaPunti();
         checkboxAggiungi.setState(true);
         disegno.impostaModPunti(Disegno.AGG_PUNTO);
			return true;
		}
		return false;
	}
}
