import java.awt.*;

class PuntoDiControllo3D extends Coordinate3D {	
   static final int DIM=3;
	
	PuntoDiControllo3D(int x, int y, int z) {
		super(x,y,z);
   }
	
	void disegna(Graphics g, int numero, int id) {
      switch (id) {
      case Viste.XY:
         g.setColor(Color.blue);
			g.drawLine(x,y-DIM,x,y+DIM);
			g.drawLine(x-DIM,y,x+DIM,y);
			g.setColor(Color.red);      
			g.drawOval(x-1,y-1,2,2);
			g.setColor(new Color(0,200,0));
			g.drawString(String.valueOf(numero),x+DIM,y+11+DIM);
         break;
      case Viste.ZY:
         g.setColor(Color.blue);
			g.drawLine(z,y-DIM,z,y+DIM);
			g.drawLine(z-DIM,y,z+DIM,y);
			g.setColor(Color.red);      
			g.drawOval(z-1,y-1,2,2);
			g.setColor(new Color(0,200,0));
			g.drawString(String.valueOf(numero),z+DIM,y+11+DIM);
         break;
      case Viste.XZ:
			g.setColor(Color.blue);
			g.drawLine(x,z-DIM,x,z+DIM);
			g.drawLine(x-DIM,z,x+DIM,z);
			g.setColor(Color.red);      
			g.drawOval(x-1,z-1,2,2);
			g.setColor(new Color(0,200,0));
			g.drawString(String.valueOf(numero),x+DIM,z+11+DIM);
			break;
      }
	}
	
   void disegna(Graphics g, String nome, Color colore, int id) {
      switch (id) {
      case Viste.XY:
         g.setColor(Color.blue);
			g.drawLine(x,y-DIM,x,y+DIM);
			g.drawLine(x-DIM,y,x+DIM,y);
			g.setColor(Color.red);      
			g.drawOval(x-1,y-1,2,2);
			g.setColor(colore);
			g.drawString(nome,x+DIM,y+11+DIM);
         break;
      case Viste.ZY:
         g.setColor(Color.blue);
			g.drawLine(z,y-DIM,z,y+DIM);
			g.drawLine(z-DIM,y,z+DIM,y);
			g.setColor(Color.red);      
			g.drawOval(z-1,y-1,2,2);
			g.setColor(colore);
			g.drawString(nome,z+DIM,y+11+DIM);
         break;
      case Viste.XZ:
			g.setColor(Color.blue);
			g.drawLine(x,z-DIM,x,z+DIM);
			g.drawLine(x-DIM,z,x+DIM,z);
			g.setColor(Color.red);      
			g.drawOval(x-1,z-1,2,2);
			g.setColor(colore);
			g.drawString(nome,x+DIM,z+11+DIM);
			break;
      }      
   }
   
   boolean vicinoA(int a, int b, int id) {
      switch (id) {
      case Viste.XY:
         return (a>=x-DIM && a<=x+DIM && b>=y-DIM && b<=y+DIM);		
      case Viste.ZY:
         return (a>=z-DIM && a<=z+DIM && b>=y-DIM && b<=y+DIM);		
      case Viste.XZ:
         return (a>=x-DIM && a<=x+DIM && b>=z-DIM && b<=z+DIM);		         
      }
		return false;
	}
}
