import java.awt.*;
import java.applet.*;



class Proiez {
	public void inversa(double a[][],double inv[][]){
		int rig;
		int col;
		double c[][] = new double[a.length-1][a.length-1];
      double deta;
		deta = det(a);
      for(rig = 0;rig <a.length;rig++){
         for(col = 0;col < a.length;col++){
            compalg(a,col,rig,c);
				inv[rig][col] = (((double)Math.pow(-1,rig+col)*det(c)))/deta;
         }
      }
      //return inv[a.length][a.length];
   }
	
	
   public void mult (double a[][],double b[][],double c[][]) {
      int rig;
		int col;
		int z;
		if (a[0].length != b.length)
         return;
      //c[][] = new double[a.length][b[1].length];
      for (rig = 0;rig < a.length;rig++){  //seleziono le righe della matrice a e c
         for(col =0;col < b[0].length;col++) { //seleziono le colonne della matrice b e c
            for (z=0;z < b.length;z++)   //seleziono gli elementi delle righe di a e delle colonne di b
               c[rig][col]+=a[rig][z]*b[z][col];
         }
      }
   }
	
	
   public double det(double a[][]){
      double d = 0;
      int rig;
      int col;
      double c[][] = new double[a.length-1][a.length-1];
		if (a.length == 1)
			return a[0][0];
		if (a.length == 2) {
         d = a[0][0]*a[1][1]-a[1][0]*a[0][1];
         return d;
      }
		rig = 0;
      for (col = 0;col < a.length;col++){
			compalg(a,rig,col,c);
			d += a[rig][col]*((double)Math.pow(-1,(rig+col)))*det(c);
      }
		return d;
   }
	
	
	
   public void compalg(double a[][],int rig,int col,double c[][]){
      int rig1;// contatore righe matrice a
      int rig2 = 0;// contatore righe matrice c
      int col1;// contatore colonne matrice a
      int col2 = 0;// contatore righe matrice a
      // First clear the return array
		for(int i=0; i<c.length; i++)
			for(int j=0; j<c.length; j++)
			c[i][j]=0;
      //creo il complemento algebrico
		for(rig1 =0;rig1 < a.length;rig1++){
         if(rig1 != rig) {
            col2 = 0;
				for(col1 = 0;col1 <a.length;col1++){
               if(col1 != col) {
                  c[rig2][col2] = a[rig1][col1];
                  col2++;
               }
            }
				rig2++;
         }
      }
		//return c[a.length-1][a.length-1];
   }
	
	
   public void trasp(double a[][],double b[][]){
	   int rig;
	   int col;
	   for(rig=0;rig<a.length;rig++){
		   for(col=0;col<a[1].length;col++){
			   b[col][rig] = a[rig][col];
		   }
	   }
   }

   public void stampaMatrix(double a[][]){
      int rig;
		int col;
		for(rig = 0;rig <a.length;rig++){
         for(col = 0;col < a[1].length;col++){
            System.out.print(a[rig][col]+" ");
         }
         System.out.println();
      }
   }

   
   public void prodvet(double v[],double n[],double c[]){
	   c[0] =(v[1]*n[2] - v[2]*n[1]);
	   c[1] =-(v[0]*n[2] - v[2]*n[0]);
	   c[2] = (v[0]*n[1] - v[1]*n[0]);
   }
   public double modulo(double v[]){
	   double modulo;
	   modulo = Math.pow(v[0],2)+Math.pow(v[1],2)+Math.pow(v[2],2);
	   Math.sqrt(modulo);
       return modulo;
   }
}
