import java.awt.*;
class ContrTipoCurva extends Panel {
	Disegno disegno;
	Choice choiceTipo;
	TextField  textFieldContinuita;
	public ContrTipoCurva(Disegno disegno) {
		this.disegno = disegno;
		/*GridBagLayout gridbag = new GridBagLayout();
		setLayout(gridbag);
		GridBagConstraints c = new GridBagConstraints();
		
		  c.fill = GridBagConstraints.HORIZONTAL;
		  c.weightx = 0.0;
		  c.weighty = 0.0;
		  c.gridwidth = 1;
		c.gridheight = 1;*/
		
		
		
		//...Where instance variables are defined:
		Choice choice; //pop-up list of choices
		
		//...Where initialization occurs:
		
		add(new Label("Tipo",Label.RIGHT));
		
		choiceTipo = new Choice();
		choiceTipo.addItem("Bezier");
		choiceTipo.addItem("B-Spline");
		add (choiceTipo);
		
		add(new Label("Continuita'",Label.RIGHT));
		
		textFieldContinuita = new TextField(2);    
		textFieldContinuita.setText(disegno.leggiContinuita());
		textFieldContinuita.setEditable(false);
		add (textFieldContinuita);
	}
	
	
	public boolean action(Event e, Object arg) {
		if (e.target instanceof Choice) {
			if (choiceTipo.getSelectedIndex()==0) {
				disegno.impostaTipoCurva(disegno.BEZIER);
				textFieldContinuita.setEditable(false);
			} else {
				disegno.impostaTipoCurva(disegno.BSPLINE);
				textFieldContinuita.setEditable(true);
			}
			
			
			//target.repaint();
			return true;
		}
		if (e.target instanceof TextField) {
			try {
				int cont = Integer.parseInt(textFieldContinuita.getText());
				disegno.impostaContinuita(cont);   				
			} catch (NumberFormatException ex) {
				textFieldContinuita.setText(disegno.leggiContinuita());
			}            
			return true;
		}
		return false;
	}
}
