import java.awt.*;

class PuntoDiControllo2D extends Coordinate2D {
	static final int DIM=3;
	
	PuntoDiControllo2D(int x, int y) {
		super(x,y);
   }
	
   void disegna(Graphics g, String id) {
      g.setColor(Color.blue);
      g.drawLine(x,y-DIM,x,y+DIM);
      g.drawLine(x-DIM,y,x+DIM,y);
      g.setColor(Color.red);
      g.drawOval(x-1,y-1,2,2);
      g.setColor(new Color(0,200,0));
      g.drawString(id,x+DIM,y+11+DIM);
   }
   
   boolean vicinoA(int a, int b) {
		return (a>=x-DIM && a<=x+DIM && b>=y-DIM && b<=y+DIM);		
	}
}
