import java.awt.*;

class ContrDisegnoCurva extends Panel {
	Disegno disegno;
	Button buttonDisegna;
   Checkbox checkboxDisAut;
	
	ContrDisegnoCurva(Disegno disegno) {
		this.disegno=disegno;
		Panel pannello=new Panel();
		
      pannello.setLayout(new GridLayout(3,1));		
		pannello.add(new Label("CURVA",Label.CENTER));
		buttonDisegna=new Button("Disegna");
		pannello.add(buttonDisegna);		
      checkboxDisAut=new Checkbox("Ridis. aut.");
      checkboxDisAut.setState(disegno.leggiRidisAut());
		pannello.add(checkboxDisAut);
		add(pannello);
	}	
	
	public boolean action(Event e, Object arg) {
		if (e.target instanceof Button) {
			disegno.disegna();				
			return true;
		}
		if (e.target instanceof Checkbox) {
			disegno.impostaRidisAut(((Checkbox)e.target).getState());
			return true;
		}
		return false;
	}
}
