import java.awt.*;

class ContrIterazioni extends Panel {
	Viste viste;
	Label labelIterazioni;
	Scrollbar scrollbarIterazioni;
	
	public ContrIterazioni(Viste viste) {
		this.viste=viste;

		add(new Label("Iterazioni",Label.RIGHT));		
		scrollbarIterazioni = new Scrollbar(Scrollbar.HORIZONTAL, 30, 20, 10, 200);		
		GridBagLayout gridbag = new GridBagLayout();
		setLayout(gridbag);
		GridBagConstraints c = new GridBagConstraints();
		c.gridwidth = GridBagConstraints.RELATIVE;
		c.weightx = 1.0;
		c.fill = GridBagConstraints.HORIZONTAL;
		gridbag.setConstraints(scrollbarIterazioni,c);
		add(scrollbarIterazioni);
		viste.impostaIterazioni(scrollbarIterazioni.getValue());		
		labelIterazioni = new Label(String.valueOf(scrollbarIterazioni.getValue()),Label.LEFT);
		add(labelIterazioni);		
	}	
	
	public boolean handleEvent(Event e) {
		if (e.target instanceof Scrollbar) {
			viste.impostaIterazioni(((Scrollbar)e.target).getValue());
			labelIterazioni.setText(String.valueOf(((Scrollbar)e.target).getValue()));
			return true;
		}
		return false;
	}
}
